<!DOCTYPE html>

<html>

<head>

<meta charset="utf-8" />
<meta name="generator" content="pandoc" />
<meta http-equiv="X-UA-Compatible" content="IE=EDGE" />

<meta name="viewport" content="width=device-width, initial-scale=1" />

<meta name="author" content="Giovanny Covarrubias-Pazaran" />

<meta name="date" content="2020-07-16" />

<title>Genetic gain calculation (historical data method)</title>



<style type="text/css">code{white-space: pre;}</style>
<style type="text/css" data-origin="pandoc">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */

</style>
<script>
// apply pandoc div.sourceCode style to pre.sourceCode instead
(function() {
  var sheets = document.styleSheets;
  for (var i = 0; i < sheets.length; i++) {
    if (sheets[i].ownerNode.dataset["origin"] !== "pandoc") continue;
    try { var rules = sheets[i].cssRules; } catch (e) { continue; }
    for (var j = 0; j < rules.length; j++) {
      var rule = rules[j];
      // check if there is a div.sourceCode rule
      if (rule.type !== rule.STYLE_RULE || rule.selectorText !== "div.sourceCode") continue;
      var style = rule.style.cssText;
      // check if color or background-color is set
      if (rule.style.color === '' && rule.style.backgroundColor === '') continue;
      // replace div.sourceCode by a pre.sourceCode rule
      sheets[i].deleteRule(j);
      sheets[i].insertRule('pre.sourceCode{' + style + '}', j);
    }
  }
})();
</script>



<style type="text/css">body {
background-color: #fff;
margin: 1em auto;
max-width: 700px;
overflow: visible;
padding-left: 2em;
padding-right: 2em;
font-family: "Open Sans", "Helvetica Neue", Helvetica, Arial, sans-serif;
font-size: 14px;
line-height: 1.35;
}
#TOC {
clear: both;
margin: 0 0 10px 10px;
padding: 4px;
width: 400px;
border: 1px solid #CCCCCC;
border-radius: 5px;
background-color: #f6f6f6;
font-size: 13px;
line-height: 1.3;
}
#TOC .toctitle {
font-weight: bold;
font-size: 15px;
margin-left: 5px;
}
#TOC ul {
padding-left: 40px;
margin-left: -1.5em;
margin-top: 5px;
margin-bottom: 5px;
}
#TOC ul ul {
margin-left: -2em;
}
#TOC li {
line-height: 16px;
}
table {
margin: 1em auto;
border-width: 1px;
border-color: #DDDDDD;
border-style: outset;
border-collapse: collapse;
}
table th {
border-width: 2px;
padding: 5px;
border-style: inset;
}
table td {
border-width: 1px;
border-style: inset;
line-height: 18px;
padding: 5px 5px;
}
table, table th, table td {
border-left-style: none;
border-right-style: none;
}
table thead, table tr.even {
background-color: #f7f7f7;
}
p {
margin: 0.5em 0;
}
blockquote {
background-color: #f6f6f6;
padding: 0.25em 0.75em;
}
hr {
border-style: solid;
border: none;
border-top: 1px solid #777;
margin: 28px 0;
}
dl {
margin-left: 0;
}
dl dd {
margin-bottom: 13px;
margin-left: 13px;
}
dl dt {
font-weight: bold;
}
ul {
margin-top: 0;
}
ul li {
list-style: circle outside;
}
ul ul {
margin-bottom: 0;
}
pre, code {
background-color: #f7f7f7;
border-radius: 3px;
color: #333;
white-space: pre-wrap; 
}
pre {
border-radius: 3px;
margin: 5px 0px 10px 0px;
padding: 10px;
}
pre:not([class]) {
background-color: #f7f7f7;
}
code {
font-family: Consolas, Monaco, 'Courier New', monospace;
font-size: 85%;
}
p > code, li > code {
padding: 2px 0px;
}
div.figure {
text-align: center;
}
img {
background-color: #FFFFFF;
padding: 2px;
border: 1px solid #DDDDDD;
border-radius: 3px;
border: 1px solid #CCCCCC;
margin: 0 5px;
}
h1 {
margin-top: 0;
font-size: 35px;
line-height: 40px;
}
h2 {
border-bottom: 4px solid #f7f7f7;
padding-top: 10px;
padding-bottom: 2px;
font-size: 145%;
}
h3 {
border-bottom: 2px solid #f7f7f7;
padding-top: 10px;
font-size: 120%;
}
h4 {
border-bottom: 1px solid #f7f7f7;
margin-left: 8px;
font-size: 105%;
}
h5, h6 {
border-bottom: 1px solid #ccc;
font-size: 105%;
}
a {
color: #0033dd;
text-decoration: none;
}
a:hover {
color: #6666ff; }
a:visited {
color: #800080; }
a:visited:hover {
color: #BB00BB; }
a[href^="http:"] {
text-decoration: underline; }
a[href^="https:"] {
text-decoration: underline; }

code > span.kw { color: #555; font-weight: bold; } 
code > span.dt { color: #902000; } 
code > span.dv { color: #40a070; } 
code > span.bn { color: #d14; } 
code > span.fl { color: #d14; } 
code > span.ch { color: #d14; } 
code > span.st { color: #d14; } 
code > span.co { color: #888888; font-style: italic; } 
code > span.ot { color: #007020; } 
code > span.al { color: #ff0000; font-weight: bold; } 
code > span.fu { color: #900; font-weight: bold; } 
code > span.er { color: #a61717; background-color: #e3d2d2; } 
</style>




</head>

<body>




<h1 class="title toc-ignore">Genetic gain calculation (historical data method)</h1>
<h4 class="author">Giovanny Covarrubias-Pazaran</h4>
<h4 class="date">2020-07-16</h4>



<p>The methods explained in the Breeding program assessment manual of EiB are:</p>
<ul>
<li><p>Expected/predicted (1)</p></li>
<li><p>Realized (2)</p></li>
<li><ul>
<li>Historical trials (2.1)</li>
</ul></li>
<li><ul>
<li><ul>
<li>Good connectivity scenario (2.1.1) (<strong>preferred method</strong>)</li>
</ul></li>
</ul></li>
<li><ul>
<li><ul>
<li>Bad connectivity scenario (2.1.2)</li>
</ul></li>
</ul></li>
<li><ul>
<li>Era trials (2.2)</li>
</ul></li>
</ul>
<p>This vignette demonstrates how to calculate the realized rate of genetic gain using historical trial data that followed good experimental design practices and check conectivity and replacement recommendations proposed by EiB to maximize accuracy of the estimates (2.1.1). This represents the ideal state of breeding programs to measure the rate of genetic gain. The values coming from this type of analyses can be considered as KPI’s to be shared with funding and collaborator institutions.</p>
<div id="introducing-the-example" class="section level2">
<h2>INTRODUCING THE EXAMPLE</h2>
<p>Assume a breeding program that has been runing for 20 years and that recycles every 5 years and that comprises the following testing stages:</p>
<ol style="list-style-type: decimal">
<li>STAGE 1</li>
<li>STAGE 2</li>
<li>STAGE 3</li>
<li>ELITE</li>
</ol>
<p>We have made available in the package 15 independent iterations of a simulated breeding program following the proposed structure using the same founding population in order to calculate and estimate the true and estimated genetic gain. The data that will be loaded has simulated that we have run a pipeline with the different stages of the breeding program that has been connected through checks. In this example we will pick the historical data of the last 20 years for the ELITE stage of testing. Each programs needs to take the decision of which testing stages or stages should be picked and the time window (here i.e. 20 years).</p>
<p>To show how the calculation is done with this type of data we first load the packages that will be required to do the analysis and visualizations.</p>
</div>
<div id="germplasm-sample-and-time-window-decisions" class="section level2">
<h2>GERMPLASM SAMPLE AND TIME WINDOW DECISIONS</h2>
<p>In practice the program needs to decide which stage or gemplasm sample and for which window of time the analysis should be performed. In this example we will then load 1 of the 15 simulated iterations available and assume we are interested in sampling the “ELITE” material that has been derived in the las “20 years” and that dta is captured in a database (i.e. EBS).</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb1-1" title="1"><span class="co">########################</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co"># define time-window and </span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co"># germplasm sample: &quot;ELITE&quot;, &quot;STAGE3&quot;, &quot;STAGE2&quot;, &quot;STAGE1&quot;</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">########################</span></a>
<a class="sourceLine" id="cb1-5" title="5">gto=<span class="dv">21</span><span class="op">:</span><span class="dv">40</span>  <span class="co"># years sampled</span></a>
<a class="sourceLine" id="cb1-6" title="6">sampleStage=<span class="st">&quot;Elite&quot;</span></a>
<a class="sourceLine" id="cb1-7" title="7">REP=<span class="dv">1</span> <span class="co"># iteration simulated</span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="kw">load</span>(<span class="kw">file.path</span>(path1,<span class="st">&quot;simulated-data&quot;</span>,<span class="kw">paste0</span>(<span class="st">&quot;BASE_&quot;</span>,REP,<span class="st">&quot;.RData&quot;</span>)))</a>
<a class="sourceLine" id="cb1-9" title="9"><span class="co"># subset to take only the last 20 years</span></a>
<a class="sourceLine" id="cb1-10" title="10">useData &lt;-<span class="st"> </span>yearData[<span class="kw">which</span>((yearData<span class="op">$</span>year <span class="op">%in%</span><span class="st"> </span>gto) <span class="op">&amp;</span><span class="st"> </span>(yearData<span class="op">$</span>stage <span class="op">%in%</span><span class="st"> </span>sampleStage)),] </a>
<a class="sourceLine" id="cb1-11" title="11"><span class="kw">head</span>(useData)</a></code></pre></div>
<pre><code>##    id mom dad generation idn env envn          g        e         ge      error
## 1 631   0   0         10 631  e1    1  0.1691366 8.824298  0.4741808 -0.5300860
## 2 632   0   0         10 632  e1    1  0.3107829 8.824298  1.3268828 -0.9135866
## 3 633   0   0         10 633  e1    1  0.1520629 8.824298  1.6228843  1.6703227
## 4 634   0   0         10 634  e1    1 -1.4849698 8.824298 -3.0389210 -0.5404107
## 5 635   0   0         10 635  e1    1 -0.7184361 8.824298 -0.9050006 -0.2575000
## 6 636   0   0         10 636  e1    1 -1.6482938 8.824298 -2.8236537  0.4238589
##           p planted year stage   type yearOrigin iteration
## 1  8.768393       1   21 Elite Checks         14    BASE_1
## 2  9.237594       1   21 Elite Checks         14    BASE_1
## 3 12.117505       1   21 Elite Checks         14    BASE_1
## 4  5.244966       1   21 Elite Checks         14    BASE_1
## 5  7.661797       1   21 Elite Checks         14    BASE_1
## 6  6.424503       1   21 Elite Checks         14    BASE_1</code></pre>
<p>Notice that in the simulated data we have identifiers for individuals, pedigree, environments tested and a check indicator. In addition, we have true genotype, environment and genotype by environment effects, although in reality this is not avaialable and needs to be estimated. The simulations allow us to see how good is a method or strategy to estimate accurately these effects. In this case will be used to see how accurate the era trials are to estimate the true genetic gain.</p>
</div>
<div id="tpe-coverage-decision" class="section level2">
<h2>TPE COVERAGE DECISION</h2>
<p>In practice the program needs to decide in which environments from the TPE the different germplasm stages will be tested to ensure that the TPE is well represented at different decision times. In this example we have simulated that historically the Elite trials have been growing in all possible environments of the TPE (in our simulation 20 20) but for the sake of illustrating the reality we will assume that only 40% of the available locations have been used to grow our ELITE material in 2 different years (20*2=40 environments; we sample 4 in each year).</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb3-1" title="1"><span class="co"># 7 out of 20 environments were planted</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">with</span>(useData, <span class="kw">table</span>(year, env))</a></code></pre></div>
<pre><code>##     env
## year e1 e2 e3 e4 e5 e6 e7 e8 e9 e10 e11 e12 e13 e14 e15 e16 e17 e18 e19 e20
##   21 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   22 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   23 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   24 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   25 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   26 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   27 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   28 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   29 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   30 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   31 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   32 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   33 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   34 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   35 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   36 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   37 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   38 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   39 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35
##   40 35 35 35 35 35 35 35 35 35  35  35  35  35  35  35  35  35  35  35  35</code></pre>
<p>And to emulate reality we will remove the data for those environments that we emulated that were not planted.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb5-1" title="1"><span class="co"># we subset to only considered environments</span></a>
<a class="sourceLine" id="cb5-2" title="2">keep &lt;-<span class="st"> </span><span class="kw">list</span>()</a>
<a class="sourceLine" id="cb5-3" title="3"><span class="cf">for</span>(iYear <span class="cf">in</span> <span class="kw">unique</span>(useData<span class="op">$</span>year)){</a>
<a class="sourceLine" id="cb5-4" title="4">  useEnvs &lt;-<span class="st"> </span><span class="kw">sample</span>(<span class="kw">unique</span>(<span class="kw">as.character</span>(useData<span class="op">$</span>env)),<span class="dv">4</span>)</a>
<a class="sourceLine" id="cb5-5" title="5">  keep[[iYear]]&lt;-<span class="kw">which</span>(useData<span class="op">$</span>env <span class="op">%in%</span><span class="st"> </span>useEnvs <span class="op">&amp;</span><span class="st"> </span>useData<span class="op">$</span>year <span class="op">==</span><span class="st"> </span>iYear)</a>
<a class="sourceLine" id="cb5-6" title="6">}; keep &lt;-<span class="st"> </span><span class="kw">unlist</span>(keep)</a>
<a class="sourceLine" id="cb5-7" title="7"><span class="co"># subset</span></a>
<a class="sourceLine" id="cb5-8" title="8">finalData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(useData[keep,]) <span class="co"># keep only environments sampled</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="co"># subset to material of interest (elite lines and checks, remove control population)</span></a>
<a class="sourceLine" id="cb5-10" title="10">finalData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(finalData[<span class="kw">which</span>(finalData<span class="op">$</span>type <span class="op">%in%</span><span class="st"> </span><span class="kw">c</span>(<span class="st">&quot;Forward&quot;</span>, <span class="st">&quot;Checks&quot;</span>)),])</a>
<a class="sourceLine" id="cb5-11" title="11"><span class="kw">with</span>(finalData, <span class="kw">table</span>(year, env))</a></code></pre></div>
<pre><code>##     env
## year e1 e2 e3 e4 e5 e6 e7 e8 e9 e10 e11 e12 e13 e14 e15 e16 e17 e18 e19 e20
##   21  0  0  0 15  0 15  0 15  0   0   0   0   0   0   0  15   0   0   0   0
##   22  0  0  0  0 15  0 15  0  0   0  15   0  15   0   0   0   0   0   0   0
##   23 15  0  0 15  0  0  0  0 15   0   0   0   0   0  15   0   0   0   0   0
##   24  0  0  0  0  0 15  0  0  0   0   0   0  15   0   0   0   0  15   0  15
##   25  0 15  0  0  0  0  0  0  0   0  15   0   0  15   0   0   0  15   0   0
##   26  0  0  0  0  0 15  0  0  0  15   0   0   0   0   0   0   0   0  15  15
##   27  0  0  0  0  0  0  0  0  0   0   0   0  15  15  15   0   0   0  15   0
##   28 15  0 15  0  0 15 15  0  0   0   0   0   0   0   0   0   0   0   0   0
##   29 15  0 15  0  0  0 15  0  0   0  15   0   0   0   0   0   0   0   0   0
##   30 15  0  0  0  0  0  0  0  0   0   0   0  15   0  15   0   0   0  15   0
##   31  0 15  0 15  0  0  0  0  0   0   0   0   0   0   0   0  15   0   0  15
##   32  0 15  0  0  0 15  0  0  0   0   0   0   0   0   0  15   0   0   0  15
##   33  0  0  0  0  0  0  0  0 15  15  15   0   0   0   0  15   0   0   0   0
##   34  0 15 15  0 15  0  0  0  0   0   0   0   0   0   0   0   0   0  15   0
##   35  0  0  0  0  0  0  0  0  0  15   0   0   0   0  15  15  15   0   0   0
##   36  0  0 15 15  0  0  0 15  0   0   0  15   0   0   0   0   0   0   0   0
##   37  0  0  0  0  0  0  0  0  0   0  15   0  15  15   0   0   0  15   0   0
##   38  0  0  0  0  0 15 15  0  0   0  15   0   0   0   0   0  15   0   0   0
##   39  0  0  0 15 15  0  0  0  0   0  15   0   0   0   0   0   0  15   0   0
##   40  0  0  0  0  0  0 15  0  0   0   0  15  15   0   0   0   0   0  15   0</code></pre>
<p>The resulting dataset contains ELITE lines and checks evaluated in 4 environments across all the years that the program has been assuming that material at the Elite stage was evaluated with 3 reps in each environment where the plot h2 was 0.2 (you can check the simulation parameters in the RUN_PROGRAM.R script available in the simulated_data folder).</p>
</div>
<div id="the-genetic-gain-calculation" class="section level2">
<h2>THE GENETIC GAIN CALCULATION</h2>
<p>Once the data has been collected from the different environments for a given germplasm sample, we can proceed to fit a mixed model. In this example we already have the simulated phenotypes and can proceed to the analysis.</p>
<div id="put-the-data-in-good-shape" class="section level3">
<h3>1) Put the data in good shape</h3>
<p>We first define some additional variables as factor to ensure a good estimation of the year and material type effects.</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb7-1" title="1">finalData<span class="op">$</span>yearf &lt;-<span class="st"> </span><span class="kw">as.factor</span>(finalData<span class="op">$</span>year) <span class="co"># convert to factor</span></a>
<a class="sourceLine" id="cb7-2" title="2">finalData<span class="op">$</span>typef &lt;-<span class="st"> </span><span class="kw">as.factor</span>(finalData<span class="op">$</span>type) <span class="co"># convert to factor</span></a>
<a class="sourceLine" id="cb7-3" title="3">finalData<span class="op">$</span>fieldinst &lt;-<span class="st"> </span><span class="kw">as.factor</span>(<span class="kw">paste0</span>(finalData<span class="op">$</span>yearf, finalData<span class="op">$</span>env))</a>
<a class="sourceLine" id="cb7-4" title="4">finalData<span class="op">$</span>fieldinstn &lt;-<span class="st"> </span><span class="kw">as.numeric</span>(finalData<span class="op">$</span>fieldinst)</a>
<a class="sourceLine" id="cb7-5" title="5">finalData &lt;-<span class="st"> </span>finalData[<span class="kw">with</span>(finalData, <span class="kw">order</span>(<span class="op">-</span>fieldinstn)), ]</a></code></pre></div>
</div>
<div id="the-mixed-model" class="section level3">
<h3>2) The mixed model</h3>
<p>With the data in good shape we can fit a mixed model of the form:</p>
<p><span class="math inline">\(y=X\beta+Zu+\epsilon\)</span></p>
<p>where year (as factor and numeric covariate) and the genotype effect are fitted as fixed effects (<span class="math inline">\(\beta\)</span>) and year by genotype interaction, year by environment, and environment, as random effects (<span class="math inline">\(u\)</span>). The residuals (<span class="math inline">\(\epsilon\)</span>) are fitted with a diagonal structure to allow for different residuals at each location.</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb8-1" title="1"><span class="co">###################</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="co"># estimated genetic gain</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="co">###################</span></a>
<a class="sourceLine" id="cb8-4" title="4">mix.var &lt;-<span class="st"> </span><span class="kw">asreml</span>(p<span class="op">~</span><span class="st"> </span>year <span class="op">+</span><span class="st"> </span>yearf <span class="op">+</span><span class="st"> </span>env <span class="op">+</span><span class="st"> </span>id,</a>
<a class="sourceLine" id="cb8-5" title="5">                  <span class="dt">random=</span> <span class="op">~</span><span class="st"> </span>yearf<span class="op">:</span>id <span class="op">+</span><span class="st"> </span>env<span class="op">:</span>id,</a>
<a class="sourceLine" id="cb8-6" title="6">                  <span class="dt">residual=</span><span class="op">~</span><span class="kw">dsum</span>(<span class="op">~</span>units <span class="op">|</span><span class="st"> </span>fieldinst),</a>
<a class="sourceLine" id="cb8-7" title="7">                  <span class="dt">data=</span><span class="kw">droplevels</span>(finalData), </a>
<a class="sourceLine" id="cb8-8" title="8">                  <span class="dt">maxiter=</span><span class="dv">50</span>, <span class="dt">workspace=</span><span class="dv">250000000</span>,<span class="dt">trace=</span><span class="ot">FALSE</span></a>
<a class="sourceLine" id="cb8-9" title="9">)</a></code></pre></div>
<pre><code>## Warning in asreml(p ~ year + yearf + env + id, random = ~yearf:id + env:id, :
## Some components changed by more than 1% on the last iteration.</code></pre>
<div class="sourceCode" id="cb10"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">head</span>(<span class="kw">summary</span>(mix.var)<span class="op">$</span>varcomp)</a></code></pre></div>
<pre><code>##                      component std.error    z.ratio bound %ch
## yearf:id          6.518175e-08        NA         NA     B  NA
## env:id            1.548019e+00 0.1500228 10.3185557     P 0.0
## fieldinst_40e7!R  3.299451e+00 1.5285364  2.1585688     P 0.4
## fieldinst_40e19!R 6.318726e-01 0.3651762  1.7303226     P 0.0
## fieldinst_40e13!R 9.530036e-01 0.6299079  1.5129253     P 0.2
## fieldinst_40e12!R 3.117978e-01 0.4704197  0.6628077     P 0.0</code></pre>
<p>Looking at the variance components it seems that most of the random effects are different than zero according to the Z.ratio.</p>
</div>
<div id="predict-means-and-merge-the-year-of-origin" class="section level3">
<h3>3) Predict means and merge the year of origin</h3>
<p>The program should be able to know what’s the year of origin (year when the material was recycled) of the materials. We can use the predict function to obtain across-location-year means for the different genotypes. Notice that not only the same genotypes show in all locations and years, on top of that checks connect the data. This is the reason why the historical data analysis represent a highly accurate estimation of genetic gain.</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb12-1" title="1">base &lt;-<span class="st"> </span><span class="kw">unique</span>(finalData[,<span class="kw">c</span>(<span class="st">&quot;id&quot;</span>,<span class="st">&quot;yearOrigin&quot;</span>,<span class="st">&quot;typef&quot;</span>)]) <span class="co"># extract year of origin for materials to merge later</span></a>
<a class="sourceLine" id="cb12-2" title="2">predictions &lt;-<span class="st"> </span><span class="kw">predict</span>(mix.var, <span class="dt">classify =</span> <span class="st">&quot;id&quot;</span>, <span class="dt">trace=</span><span class="ot">FALSE</span>)<span class="co"># obtain across years and across environment means</span></a></code></pre></div>
<pre><code>## Warning in asreml(fixed = p ~ year + yearf + env + id, random = ~yearf:id + :
## Some components changed by more than 1% on the last iteration.</code></pre>
<div class="sourceCode" id="cb14"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb14-1" title="1">predictions2 &lt;-<span class="st"> </span>predictions<span class="op">$</span>pvals <span class="co"># extract adjusted means</span></a>
<a class="sourceLine" id="cb14-2" title="2">predictions3 &lt;-<span class="st"> </span><span class="kw">merge</span>(predictions2, base, <span class="dt">by=</span><span class="st">&quot;id&quot;</span>, <span class="dt">all.x =</span> <span class="ot">TRUE</span>) <span class="co"># add year of origin to adjusted means</span></a>
<a class="sourceLine" id="cb14-3" title="3">predictions3 &lt;-<span class="st"> </span>predictions3[<span class="kw">which</span>(predictions3<span class="op">$</span>typef <span class="op">==</span><span class="st"> &quot;Forward&quot;</span>),] <span class="co"># remove checks</span></a>
<a class="sourceLine" id="cb14-4" title="4"><span class="kw">head</span>(predictions3)</a></code></pre></div>
<pre><code>##       id predicted.value std.error    status yearOrigin   typef
## 1 221722       11.905677 0.9970694 Estimable         14 Forward
## 2 222410       12.498125 0.9970694 Estimable         14 Forward
## 3 222459       11.636365 0.9970694 Estimable         14 Forward
## 4 222530        9.821295 0.9970694 Estimable         14 Forward
## 5 222637       10.203034 0.9970694 Estimable         14 Forward
## 6 231799       13.981406 0.8659097 Estimable         15 Forward</code></pre>
<p>Notice that prediction are linked not only to specific genotypes but now we also have the year of origin of each material.</p>
</div>
<div id="the-response-to-selection-and-rate-of-gain" class="section level3">
<h3>4) The response to selection and rate of gain</h3>
<p>This results can be used to calculate the response to selection obtained by year:</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb16-1" title="1">R0 &lt;-<span class="st"> </span><span class="kw">aggregate</span>(predicted.value<span class="op">~</span>yearOrigin,<span class="dt">data=</span>predictions3, <span class="dt">FUN=</span>mean)</a>
<a class="sourceLine" id="cb16-2" title="2"><span class="kw">mean</span>(<span class="kw">diff</span>(R0<span class="op">$</span>predicted.value)) <span class="co"># mean response per year</span></a></code></pre></div>
<pre><code>## [1] 0.2461564</code></pre>
<div class="sourceCode" id="cb18"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb18-1" title="1">R0<span class="op">$</span>predicted.value[<span class="kw">nrow</span>(R0)] <span class="op">-</span><span class="st"> </span>R0<span class="op">$</span>predicted.value[<span class="dv">1</span>]<span class="co"># total response across years</span></a></code></pre></div>
<pre><code>## [1] 4.676971</code></pre>
<p>Is more effective if we fit a linear model and use the slope of the regression as the rate of gain per year:</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb20-1" title="1">mix.var2 &lt;-<span class="st"> </span><span class="kw">lm</span>(predicted.value<span class="op">~</span>yearOrigin, <span class="dt">data=</span>predictions3) <span class="co"># fit the second model</span></a>
<a class="sourceLine" id="cb20-2" title="2">b2=<span class="kw">summary</span>(mix.var2)<span class="op">$</span>coefficients[<span class="dv">2</span>,<span class="dv">1</span>]; b2 <span class="co"># extract rate of genetic gain</span></a></code></pre></div>
<pre><code>## [1] 0.189686</code></pre>
<p>As we mentioned at the beggining since we simulated the data we know the real rate of genetic gain:</p>
<div class="sourceCode" id="cb22"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb22-1" title="1"><span class="co"># true genetic gain</span></a>
<a class="sourceLine" id="cb22-2" title="2">realGainData &lt;-<span class="st"> </span><span class="kw">droplevels</span>(useData[<span class="kw">which</span>(useData<span class="op">$</span>type <span class="op">%in%</span><span class="st"> </span><span class="kw">c</span>(<span class="st">&quot;Forward&quot;</span>)),]) <span class="co"># filter original data to only forward breeding material (no checks or control population)</span></a>
<a class="sourceLine" id="cb22-3" title="3">realGainData &lt;-<span class="st"> </span><span class="kw">aggregate</span>(g<span class="op">~</span>id<span class="op">+</span>yearOrigin,<span class="dt">data=</span>realGainData, <span class="dt">FUN=</span>mean) <span class="co"># aggregate by year of origin</span></a>
<a class="sourceLine" id="cb22-4" title="4">mix.var.true &lt;-<span class="st"> </span><span class="kw">lm</span>(g<span class="op">~</span>yearOrigin, <span class="dt">data=</span>realGainData) <span class="co"># fit a model for true genetic gain</span></a>
<a class="sourceLine" id="cb22-5" title="5">b2=<span class="kw">summary</span>(mix.var.true)<span class="op">$</span>coefficients[<span class="dv">2</span>,<span class="dv">1</span>]; b2 <span class="co"># extract true rate of genetic gain</span></a></code></pre></div>
<pre><code>## [1] 0.1582083</code></pre>
</div>
</div>
<div id="final-remarks" class="section level2">
<h2>Final remarks</h2>
<p>As can be seen the two rates are very similar which shows that a historical data based analysis can be good to estimate the rate of gain. Following Excellence in Breeding recommendations on connectivity of trials using checks in order to be able to use historical data to calculate the rate of gain is the preferred method given the cost and accuracy.</p>
</div>
<div id="literature" class="section level2">
<h2>Literature</h2>
<p>Covarrubias-Pazaran G. 2020. Genetic gain as a high level key performance indicator. <a href="https://excellenceinbreeding.org/toolbox/tools/eib-breeding-scheme-optimization-manuals" class="uri">https://excellenceinbreeding.org/toolbox/tools/eib-breeding-scheme-optimization-manuals</a></p>
<p>Walsh, B. 2004. Population-and quantitative-genetic models of selection limits. Plant breeding reviews 24.1: 177-226.</p>
</div>



<!-- code folding -->


<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src  = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script>

</body>
</html>
